"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

exports.__esModule = true;
exports.shape = shape;
exports.default = void 0;

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _Builder2 = _interopRequireDefault(require("./Builder"));

var _isObject = _interopRequireDefault(require("./isObject"));

var ShapeBuilder = function (_Builder) {
  (0, _inheritsLoose2.default)(ShapeBuilder, _Builder);

  function ShapeBuilder(contents) {
    var _this;

    _this = _Builder.call(this, 'shape', {}) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "contents", void 0);

    if ("production" !== process.env.NODE_ENV) {
      var _context;

      _this.invariant((0, _isObject.default)(contents) && (0, _keys.default)(contents).length > 0 && (0, _every.default)(_context = (0, _keys.default)(contents)).call(_context, function (key) {
        return contents[key] instanceof _Builder2.default;
      }), 'A non-empty object of properties to blueprints are required for a shape.');
    }

    _this.contents = contents;
    return _this;
  }

  var _proto = ShapeBuilder.prototype;

  _proto.runChecks = function runChecks(path, initialValue, struct, options) {
    var _context2,
        _this2 = this;

    if (options === void 0) {
      options = {};
    }

    var value = {};
    var object = initialValue || this.defaultValue || {};

    if ("production" !== process.env.NODE_ENV) {
      this.invariant(typeof object === 'object' && !!object, 'Value passed to shape must be an object.', path);
    }

    (0, _forEach.default)(_context2 = (0, _keys.default)(this.contents)).call(_context2, function (baseKey) {
      var key = baseKey;
      var builder = _this2.contents[key];

      if (builder instanceof _Builder2.default) {
        value[key] = builder.runChecks(path + "." + key, object[key], object, options);
      } else {
        value[key] = object[key];
      }
    });
    return value;
  };

  return ShapeBuilder;
}(_Builder2.default);

exports.default = ShapeBuilder;

function shape(contents) {
  return new ShapeBuilder(contents);
}