"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

require("core-js/modules/es.array.join");

exports.__esModule = true;
exports.union = union;
exports.default = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _Builder2 = _interopRequireDefault(require("./Builder"));

var _typeOf = _interopRequireDefault(require("./typeOf"));

var UnionBuilder = function (_Builder) {
  (0, _inheritsLoose2.default)(UnionBuilder, _Builder);

  function UnionBuilder(builders, defaultValue) {
    var _this;

    _this = _Builder.call(this, 'union', defaultValue) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "builders", []);

    if ("production" !== process.env.NODE_ENV) {
      _this.invariant((0, _isArray.default)(builders) && builders.length > 0 && (0, _every.default)(builders).call(builders, function (builder) {
        return builder instanceof _Builder2.default;
      }), 'A non-empty array of blueprints are required for a union.');

      _this.builders = builders;

      _this.addCheck(_this.checkUnions, builders);
    }

    return _this;
  }

  var _proto = UnionBuilder.prototype;

  _proto.checkUnions = function checkUnions(path, value, builders) {
    var _this2 = this;

    if ("production" !== process.env.NODE_ENV) {
      var usage = {};
      var keys = [];
      var type = (0, _typeOf.default)(value);
      (0, _forEach.default)(builders).call(builders, function (builder) {
        if (usage[builder.type]) {
          _this2.invariant(false, "Multiple instances of \"" + builder.type + "\" are not supported.", path);
        } else if (builder.type === 'union') {
          _this2.invariant(false, 'Nested unions are not supported.', path);
        } else {
          usage[builder.type] = true;
          keys.push(builder.typeAlias());
        }
      });

      if (usage.shape && usage.object) {
        this.invariant(false, 'Objects and shapes within the same union are not supported.', path);
      }

      var checked = false;
      (0, _forEach.default)(builders).call(builders, function (builder) {
        if (type === builder.type || type === 'object' && builder.type === 'shape' || builder.type === 'custom') {
          checked = true;
          builder.runChecks(path, value, _this2.currentStruct, _this2.options);
        }
      });
      this.invariant(checked, "Type must be one of: " + keys.join(', '), path);
    }
  };

  _proto.typeAlias = function typeAlias() {
    var _context;

    return (0, _map.default)(_context = this.builders).call(_context, function (builder) {
      return builder.typeAlias();
    }).join(' | ');
  };

  return UnionBuilder;
}(_Builder2.default);

exports.default = UnionBuilder;

function union(builders, defaultValue) {
  return new UnionBuilder(builders, defaultValue);
}